/* dis9830: a portable disassembler for the HP 9830A/B calculator */
/* Copyright (c) 2013-2014, Robert Ferguson (rob@bitscience.ca) */
/* All rights reserved; see LICENSE for details */

/* 
 * Not entirely happy about C99 initializers, but it's the best way 
 * to keep the OPCODE_ defines and the array indexes in sync. 
 */

char *opasm[] = {

/* Memory Reference Group: */

[OPCODE_ADR] = 	"AD%c",
[OPCODE_CPR] =	"CP%c",
[OPCODE_LDR] =	"LD%c",
[OPCODE_STR] =	"ST%c",
[OPCODE_IOR] =	"IOR",
[OPCODE_ISZ] =	"ISZ",
[OPCODE_AND] =	"AND",
[OPCODE_DSZ] =	"DSZ",
[OPCODE_JSM] =	"JSM",
[OPCODE_JMP] =	"JMP",

/* D/I Reference Group: */

[OPCODE_ADRg] =	"AD%c",
[OPCODE_CPRg] =	"CP%c",
[OPCODE_LDRg] =	"LD%c",
[OPCODE_STRg] =	"ST%c",
[OPCODE_IORg] =	"IOR",
[OPCODE_ISZg] =	"ISZ",
[OPCODE_ANDg] =	"AND",
[OPCODE_DSZg] =	"DSZ",
[OPCODE_JSMg] =	"JSM",
[OPCODE_JMPg] =	"JMP",
[OPCODE_EXR] =	"EX%c", 
[OPCODE_DMA] =	"DMA",
[OPCODE_CMR] =	"CM%c",
[OPCODE_TCR] =	"TC%c", 

/* Shift-Rotate Group: */

[OPCODE_ARR] =	"A%cR",
[OPCODE_SRR] =	"S%cR",
[OPCODE_SRL] =	"S%cL",
[OPCODE_RRR] =	"R%cR",

/* Alter-Skip Group: */

[OPCODE_SZR] =	"SZ%c",
[OPCODE_RZR] =	"RZ%c",
[OPCODE_SIR] =	"SI%c",
[OPCODE_RIR] =	"RI%c",
[OPCODE_SLR] =	"SL%c",
[OPCODE_SRM] =	"S%cM",
[OPCODE_SRP] =	"S%cP",
[OPCODE_SES] =	"SES",
[OPCODE_SEC] =	"SEC",

/* Input/Output Group: */

[OPCODE_STF] =	"STF",
[OPCODE_CLF] =	"CLF",
[OPCODE_SFC] =	"SFC",
[OPCODE_SFS] =	"SFS",
[OPCODE_CLC] =	"CLC",
[OPCODE_STC] =	"STC",
[OPCODE_OTR] =	"OT%c",
[OPCODE_LIR] =	"LI%c",
[OPCODE_MIR] =	"MI%c",

/* MAC Group: */

[OPCODE_RET] =	"RET",
[OPCODE_MOV] =	"MOV",
[OPCODE_CLR] =	"CLR", 
[OPCODE_XFR] =	"XFR",
[OPCODE_MRX] =	"MRX",
[OPCODE_MRY] =	"MRY",
[OPCODE_MLS] =	"MLS",
[OPCODE_DRS] =	"DRS",
[OPCODE_DLS] =	"DLS",
[OPCODE_FXA] =	"FXA",
[OPCODE_FMP] =	"FMP",
[OPCODE_FDV] =	"FDV",
[OPCODE_CMX] =	"CMX",
[OPCODE_CMY] =	"CMY",
[OPCODE_MDI] =	"MDI",
[OPCODE_NRM] =	"NRM",
[OPCODE_DATA] = "DW "};
